#!/bin/bash

cd $(dirname $(realpath -s ${0}))

RULES=()

function generate_rule() {
  file=${1}
  filename=${2}

  RULES+=("${filename}.html")
  echo "${filename}.html: ${file}" >> Makefile.wip
  echo "	\$(PUG) ${file}" >> Makefile.wip
}

function finalize() {
  echo -n "all:" >> Makefile
  for rule in "${RULES[@]}"; do
    echo -n " $rule" >> Makefile
  done
  echo >> Makefile
  cat Makefile.wip >> Makefile
  rm Makefile.wip
}

cat <<EOF > Makefile
PUG = \$(shell pwd)/node_modules/pug-cli/index.js --basedir .
EOF
for file in *.pug **/*.pug; do
  filename=${file##*/}
  if [[ ${filename} != _* ]]; then
    generate_rule ${file} ${file%.*}
  fi
done

finalize